             .title        "Famicom Jump II Plugin"

;05/05/07
;BootGod

             ;vectors for standard system calls

send_byte:   .equ 0200h
baton:       .equ 0203h
chk_vram:    .equ 0206h
chk_wram:    .equ 0209h
wr_ppu:      .equ 020ch
read_byte:   .equ 020fh
init_crc:    .equ 0212h
do_crc:      .equ 0215h
finish_crc:  .equ 0218h

crc0:        .equ 0080h
crc1:        .equ 0081h
crc2:        .equ 0082h
crc3:        .equ 0083h

address:       .equ 00e0h
address_lo:    .equ 00e0h
address_hi:    .equ 00e1h
curbank:    .equ 00e2h
banksleft:    .equ 00e3h
bank0crc:  .equ 00e4h

reg:       .equ 00e8h
reg_lo:    .equ 00e8h
reg_hi:    .equ 00e9h

numpages_lo .equ 00eah
numpages_hi .equ 00ebh


temp:    .equ 00ech

;plugin header defines
p_ver: = 1	;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "Bandai BA-JUMP2 "
             .db "(Famicom Jump II)"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "BootGod"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 512 >> 4,0 >> 4
             .db 0 >> 3,0 >> 3
             .db 8,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here

             
;mirroring is mapper controlled

             lda #4
             jsr send_byte

;send size info

got_prg:     lda #0		;send PRG header
             jsr send_byte
             lda #8
             jsr send_byte
             lda #001h
             jsr send_byte

             lda #0
             sta curbank
             lda #32
             sta banksleft

next_prg:    lda curbank
             jsr wr_pbank	;write cur bank num
             inc curbank

             lda #0
             sta address_lo
             lda #080h
             sta address_hi	;set address to $8000

             ldy #0
             ldx #64		;setup for 16K bank dump

dump_prg:    lda (address),y
             jsr send_byte
             iny
             bne dump_prg
             inc address_hi
             dex
             bne dump_prg
             dec banksleft
             bne next_prg
             

do_wram:     lda #32
             jsr send_byte
             lda #0
             jsr send_byte
             lda #3
             jsr send_byte

             lda #0
             sta address_lo
             lda #060h
             sta address_hi	;set address to $6000

             ldy #0
             ldx #32		;setup for 8K bank dump

dump_wram:   lda (address),y
             jsr send_byte
             iny
             bne dump_wram
             inc address_hi
             dex
             bne dump_wram

finished:    lda #000h		;send termination header
             jsr send_byte
             lda #000h
             jsr send_byte
             lda #000h
             jsr send_byte

             rts

wr_pbank:    sta temp
             and #10h
             lsr a
             lsr a
             lsr a
             lsr a
             sta 8000h
             sta 8001h
             sta 8002h
             sta 8003h
             sta 8004h
             sta 8005h
             sta 8006h
             sta 8007h
             lda temp
             and #0fh
             sta 8008h
             rts

             .fill 0800h-*,0ffh   ;fill rest to get 1K of data

             .end